#include "partition.h"
#include "bits/stdc++.h"

using namespace std;

std::vector<int> solve(std::vector<int> A) {
    int n = A.size();
    vector<pair<int,int>>B;
    for(int i = 0; i < n; i ++)
        B.emplace_back(A[i],i);
    sort(begin(B),end(B));
    long long sm = 0;
    for (int i : A) sm += i;
    for (int i = n/2; i >= 1; i ++) {
        long long smA = 0;
        for (int j = 0; j < i; j ++)
            smA+=B[j].first;
        if(smA-B[i-1].first>sm/2)
            continue;
        for(int j=i;j<n;j++){
            smA-=B[j-i].first;
            smA+=B[j].first;
            if(smA>sm/2){
                vector<int>ans;
                for(int k=j-i+1;k<=j;k++)
                    ans.push_back(B[k].second);
                for(int k=0;k<=j-i;k++)
                    ans.push_back(B[k].second);
                for(int k=j+1;k<n;k++)
                    ans.push_back(B[k].second);
                return ans;
            }
        }
    }
    vector<int>ans(n);
    iota(begin(ans),end(ans),0);
    return ans;
}